"use strict";
Object.defineProperty(exports, Symbol.toStringTag, { value: "Module" });
const P = require("vue"), T = require("@nextcloud/axios"), b = require("@nextcloud/vue/dist/Components/NcButton.js"), x = require("@nextcloud/vue/dist/Components/NcModal.js"), M = require("@nextcloud/vue/dist/Components/NcPasswordField.js"), D = require("@nextcloud/router"), N = require("@nextcloud/l10n/gettext"), u = (o) => o && o.__esModule ? o : { default: o }, g = /* @__PURE__ */ u(P), $ = /* @__PURE__ */ u(T), E = /* @__PURE__ */ u(b), q = /* @__PURE__ */ u(x), L = /* @__PURE__ */ u(M), m = "password-confirmation-dialog", k = "modal-mask", h = N.getGettextBuilder().detectLocale();
[].map(({ locale: o, json: e }) => h.addTranslation(o, e));
const f = h.build();
f.ngettext.bind(f);
const l = f.gettext.bind(f), B = g.default.extend({
  name: "PasswordDialog",
  components: {
    NcButton: E.default,
    NcModal: q.default,
    NcPasswordField: L.default
  },
  data() {
    return {
      password: "",
      showError: !1,
      dialogId: m,
      titleText: l("Confirm your password"),
      subtitleText: l("This action needs authentication"),
      passwordLabelText: l("Password"),
      errorText: l("Wrong password"),
      confirmText: l("Confirm")
    };
  },
  mounted() {
    this.$nextTick(() => {
      this.$refs.field.$el.querySelector('input[type="password"]').focus();
    });
  },
  methods: {
    async confirm() {
      this.showError = !1;
      const o = D.generateUrl("/login/confirm");
      try {
        if (this.password !== "") {
          const { data: e } = await $.default.post(o, { password: this.password });
          window.nc_lastLogin = e.lastLogin, this.$emit("confirmed");
        }
      } catch {
        this.showError = !0;
      }
    },
    close() {
      this.$emit("close");
    }
  }
});
function S(o, e, s, r, a, d, c, _) {
  var t = typeof o == "function" ? o.options : o;
  e && (t.render = e, t.staticRenderFns = s, t._compiled = !0), r && (t.functional = !0), d && (t._scopeId = "data-v-" + d);
  var i;
  if (c ? (i = function(n) {
    n = n || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !n && typeof __VUE_SSR_CONTEXT__ < "u" && (n = __VUE_SSR_CONTEXT__), a && a.call(this, n), n && n._registeredComponents && n._registeredComponents.add(c);
  }, t._ssrRegister = i) : a && (i = _ ? function() {
    a.call(
      this,
      (t.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : a), i)
    if (t.functional) {
      t._injectStyles = i;
      var y = t.render;
      t.render = function(C, p) {
        return i.call(p), y(C, p);
      };
    } else {
      var w = t.beforeCreate;
      t.beforeCreate = w ? [].concat(w, i) : [i];
    }
  return {
    exports: o,
    options: t
  };
}
var A = function() {
  var e = this, s = e._self._c;
  return e._self._setupProxy, s("NcModal", { staticClass: "dialog", attrs: { id: e.dialogId, size: "small", container: null }, on: { close: e.close } }, [s("div", { staticClass: "dialog__container" }, [s("h2", { staticClass: "dialog__title" }, [e._v(" " + e._s(e.titleText) + " ")]), s("p", [e._v(e._s(e.subtitleText))]), s("NcPasswordField", { ref: "field", attrs: { value: e.password, label: e.passwordLabelText, "helper-text": e.showError ? e.errorText : "", error: e.showError, required: "" }, on: { "update:value": function(r) {
    e.password = r;
  }, keydown: function(r) {
    return !r.type.indexOf("key") && e._k(r.keyCode, "enter", 13, r.key, "Enter") ? null : e.confirm.apply(null, arguments);
  } } }), s("NcButton", { staticClass: "dialog__button", attrs: { type: "primary", disabled: !e.password, "aria-label": e.confirmText }, on: { click: e.confirm } }, [e._v(" " + e._s(e.confirmText) + " ")])], 1)]);
}, R = [], O = /* @__PURE__ */ S(
  B,
  A,
  R,
  !1,
  null,
  "c0bff800",
  null,
  null
);
const F = O.exports, I = Date.now(), v = () => {
  const o = I - window.nc_pageLoad * 1e3, e = Date.now() - (o + window.nc_lastLogin * 1e3);
  return window.backendAllowsPasswordConfirmation && e > 30 * 60 * 1e3;
}, V = () => {
  if (!!document.getElementById(m))
    return Promise.reject(new Error(l("Password confirmation dialog already mounted")));
  if (!v())
    return Promise.resolve();
  const e = document.createElement("div");
  e.setAttribute("id", m);
  const s = document.querySelectorAll(".".concat(k));
  !!s.length ? s[s.length - 1].prepend(e) : document.body.prepend(e);
  const a = g.default.extend(F), d = new a().$mount(e);
  return new Promise((c, _) => {
    d.$on("confirmed", () => {
      d.$destroy(), c();
    }), d.$on("close", () => {
      d.$destroy(), _(new Error("Dialog closed"));
    });
  });
};
exports.confirmPassword = V;
exports.isPasswordConfirmationRequired = v;
