import w from "vue";
import y from "@nextcloud/axios";
import C from "@nextcloud/vue/dist/Components/NcButton.js";
import T from "@nextcloud/vue/dist/Components/NcModal.js";
import b from "@nextcloud/vue/dist/Components/NcPasswordField.js";
import { generateUrl as P } from "@nextcloud/router";
import { getGettextBuilder as x } from "@nextcloud/l10n/gettext";
const m = "password-confirmation-dialog", D = "modal-mask", g = x().detectLocale();
[].map(({ locale: t, json: o }) => g.addTranslation(t, o));
const f = g.build();
f.ngettext.bind(f);
const l = f.gettext.bind(f), $ = w.extend({
  name: "PasswordDialog",
  components: {
    NcButton: C,
    NcModal: T,
    NcPasswordField: b
  },
  data() {
    return {
      password: "",
      showError: !1,
      dialogId: m,
      titleText: l("Confirm your password"),
      subtitleText: l("This action needs authentication"),
      passwordLabelText: l("Password"),
      errorText: l("Wrong password"),
      confirmText: l("Confirm")
    };
  },
  mounted() {
    this.$nextTick(() => {
      this.$refs.field.$el.querySelector('input[type="password"]').focus();
    });
  },
  methods: {
    async confirm() {
      this.showError = !1;
      const t = P("/login/confirm");
      try {
        if (this.password !== "") {
          const { data: o } = await y.post(t, { password: this.password });
          window.nc_lastLogin = o.lastLogin, this.$emit("confirmed");
        }
      } catch {
        this.showError = !0;
      }
    },
    close() {
      this.$emit("close");
    }
  }
});
function E(t, o, r, s, a, d, c, u) {
  var e = typeof t == "function" ? t.options : t;
  o && (e.render = o, e.staticRenderFns = r, e._compiled = !0), s && (e.functional = !0), d && (e._scopeId = "data-v-" + d);
  var i;
  if (c ? (i = function(n) {
    n = n || // cached call
    this.$vnode && this.$vnode.ssrContext || // stateful
    this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext, !n && typeof __VUE_SSR_CONTEXT__ < "u" && (n = __VUE_SSR_CONTEXT__), a && a.call(this, n), n && n._registeredComponents && n._registeredComponents.add(c);
  }, e._ssrRegister = i) : a && (i = u ? function() {
    a.call(
      this,
      (e.functional ? this.parent : this).$root.$options.shadowRoot
    );
  } : a), i)
    if (e.functional) {
      e._injectStyles = i;
      var h = e.render;
      e.render = function(v, p) {
        return i.call(p), h(v, p);
      };
    } else {
      var _ = e.beforeCreate;
      e.beforeCreate = _ ? [].concat(_, i) : [i];
    }
  return {
    exports: t,
    options: e
  };
}
var L = function() {
  var o = this, r = o._self._c;
  return o._self._setupProxy, r("NcModal", { staticClass: "dialog", attrs: { id: o.dialogId, size: "small", container: null }, on: { close: o.close } }, [r("div", { staticClass: "dialog__container" }, [r("h2", { staticClass: "dialog__title" }, [o._v(" " + o._s(o.titleText) + " ")]), r("p", [o._v(o._s(o.subtitleText))]), r("NcPasswordField", { ref: "field", attrs: { value: o.password, label: o.passwordLabelText, "helper-text": o.showError ? o.errorText : "", error: o.showError, required: "" }, on: { "update:value": function(s) {
    o.password = s;
  }, keydown: function(s) {
    return !s.type.indexOf("key") && o._k(s.keyCode, "enter", 13, s.key, "Enter") ? null : o.confirm.apply(null, arguments);
  } } }), r("NcButton", { staticClass: "dialog__button", attrs: { type: "primary", disabled: !o.password, "aria-label": o.confirmText }, on: { click: o.confirm } }, [o._v(" " + o._s(o.confirmText) + " ")])], 1)]);
}, M = [], k = /* @__PURE__ */ E(
  $,
  L,
  M,
  !1,
  null,
  "c0bff800",
  null,
  null
);
const A = k.exports, N = Date.now(), B = () => {
  const t = N - window.nc_pageLoad * 1e3, o = Date.now() - (t + window.nc_lastLogin * 1e3);
  return window.backendAllowsPasswordConfirmation && o > 30 * 60 * 1e3;
}, G = () => {
  if (!!document.getElementById(m))
    return Promise.reject(new Error(l("Password confirmation dialog already mounted")));
  if (!B())
    return Promise.resolve();
  const o = document.createElement("div");
  o.setAttribute("id", m);
  const r = document.querySelectorAll(".".concat(D));
  !!r.length ? r[r.length - 1].prepend(o) : document.body.prepend(o);
  const a = w.extend(A), d = new a().$mount(o);
  return new Promise((c, u) => {
    d.$on("confirmed", () => {
      d.$destroy(), c();
    }), d.$on("close", () => {
      d.$destroy(), u(new Error("Dialog closed"));
    });
  });
};
export {
  G as confirmPassword,
  B as isPasswordConfirmationRequired
};
